export declare class DilithiumKeyPair {
    id: string;
    type: string;
    controller: string;
    publicKeyJwk: any;
    privateKeyJwk: any;
    static generate(): Promise<DilithiumKeyPair>;
    static from(kp: any): Promise<DilithiumKeyPair>;
    constructor(kp: any);
    signer(type?: "CRYDI3"): {
        sign({ data }: {
            data: Uint8Array;
        }): Promise<Uint8Array>;
    };
    verifier(type?: "CRYDI3"): {
        verify({ data, signature, }: {
            data: Uint8Array;
            signature: Uint8Array;
        }): Promise<boolean>;
    };
}
